// SPDX-License-Identifier: LGPL-3.0-or-later
// See Notices.txt for copyright information

use crate::{
    config::{CpuConfig, CpuConfigType},
    instruction::{MOpDestReg, PRegNum},
    unit::RetireQueueIndex,
};
use fayalite::prelude::*;

#[hdl(no_static)]
pub struct RenameRetireInterface<C: Type + CpuConfigType> {
    pub start_retire_queue_index: RetireQueueIndex<C>,
    #[hdl(flip)]
    pub end_retire_queue_index: RetireQueueIndex<C>,
}

#[hdl(no_static)]
pub struct RetireQueueEntry<C: Type + CpuConfigType> {
    pub mop_dest: MOpDestReg,
    pub renamed_dest: PRegNum<C>,
}

type C = PhantomConst<CpuConfig>;

#[hdl_module]
pub fn retire_queue(config: PhantomConst<CpuConfig>) {
    #[hdl]
    let cd: ClockDomain = m.input();
    #[hdl]
    let rename_retire_interface: RenameRetireInterface<C> = m.output(RenameRetireInterface[config]);
    todo!();
}
